#include <stdio.h>
#include <stdlib.h>

#import <Foundation/Foundation.h>
#include <StepTalk/StepTalk.h>


int main (int argc, const char * argv[]) {
    NSAutoreleasePool * pool = [[NSAutoreleasePool alloc] init];

//    STEnvironmentDescription *stenvdesc = [STEnvironmentDescription descriptionWithName: defaultDescriptionName@"MolTalk"];
    STEnvironmentDescription *stenvdesc = [STEnvironmentDescription descriptionWithName: [STEnvironmentDescription defaultDescriptionName] ];
    if (!stenvdesc)
    {
            [NSException raise: @"Unsupported" format: @"cannot find scripting description."];
            return (-1);
    }
    STEnvironment *stenvironment = [STEnvironment environmentWithDescription: stenvdesc];
    [stenvironment setFullScriptingEnabled: NO];
    [stenvironment loadModule:@"SimpleTranscript"];

    STEngine *stengine = [STEngine engineForLanguageWithName:@"Smalltalk"];
    NSLog(@"have engine: %@\n",stengine);
    
    NSString *theScript = [NSString stringWithContentsOfFile:@"TestScript.st"];
    NSLog(@"executing script:\n%@",theScript);
    id result;
    NS_DURING
    result = [stengine executeCode:theScript inEnvironment:stenvironment];
    NS_HANDLER
    /* handle the exception */
    NSLog(@"exception occured: %@",localException);
    NS_ENDHANDLER

    NSLog(@"all done.");

    [pool release];
    return 0;
}
